/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Antonino Stefano Borgia <stefano.borgia@pd.infn.it>
 *
 */

import java.io.File;

import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * 
 */
public class MonitorTestSuite {

   public static void main( String[] args ) {
   }



   public static Test suite( ) {
//   	// set up environment:
////   	  System.setProperty("resourceURI","/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor/test/");
////   	  System.setProperty("sensorConfigURI","/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor/test/conf/");
////   	  System.setProperty("sensorURI","/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor/test/conf");
//   	  System.setProperty("sensorURI","/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor/test/");
//   	  System.setProperty("sensorConfigURI","/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor/");
//   	
//   	  // ho dovuto creare la cartella log: viene cancellata da ant al termine della compilazione?
////   	  System.setProperty("test.log.dir","/home/borgia/usr/eclipse/TMPWorkspace/org.glite.ce.monitor/test/log/");
////   	  System.setProperty("test.conf.dir","/home/borgia/usr/eclipse/TMPWorkspace/org.glite.ce.monitor/test/conf/");

   	  

		//by now i'm testing only initialization phase, so i remove previously created sensorConfig.xml
		// otherwise the deserialization phase would start
	   	File sensorConfigFile = new File("/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor/test/sensorConfig.xml");
	   	File queryProcessorConfigFile = new File("/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor/test/queryProcessorConfig.xml");
	   	File actionConfigFile = new File("/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor/test/actionConfig.xml");
	    if(sensorConfigFile.exists()){
	    	System.out.println("deleting sensorConfig.xml");
	    	sensorConfigFile.delete();
	    }
	    if(queryProcessorConfigFile.exists()){
	    	System.out.println("deleting queryProcessorConfig.xml");
	    	queryProcessorConfigFile.delete();
	    }
	    if(actionConfigFile.exists()){
	    	System.out.println("deleting actionConfigFile.xml");
	    	actionConfigFile.delete();
	    }

	
	
	
      TestSuite suite = new TestSuite( "Test for default package" );
      //$JUnit-BEGIN$
      suite.addTestSuite( CEMonitorServiceTest.class ); // OK
      suite.addTestSuite( ResourceRegistryTest.class ); // OK
      suite.addTestSuite( SubscriptionPersistentTest.class ); // OK ma lascia default.reg
      suite.addTestSuite( SubscriptionRegistryTest.class ); // OK ma lascia subscription.reg
      suite.addTestSuite( TopicHolderTest.class ); //OK!
      suite.addTestSuite( SensorHolderTest.class );  // OK!
      suite.addTestSuite( ActionHolderTest.class );  // OK!
      suite.addTestSuite( QueryProcessorHolderTest.class ); // OK!
      suite.addTestSuite( PredefinedSubscriptionHolderTest.class ); // 50% (typeMapping)
      suite.addTestSuite( NotificationHolderTest.class ); //OK
      suite.addTestSuite( ClassAdProcessorTest.class ); // OK
      suite.addTestSuite( JarClassLoaderTest.class ); // OK muovere su org.glite.ce.common-java
      suite.addTestSuite ( RegExProcessorTest.class); // OK
      suite.addTestSuite ( SendNotificationActionTest.class); // OK
      suite.addTestSuite ( SendExpiredNotificationActionTest.class); // OK
      suite.addTestSuite ( DoNotSendNotificationActionTest.class); // OK
      suite.addTestSuite( SubscriptionHandlerTest.class ); // OK

      

      //$JUnit-END$
      return suite;
   }
}
