/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Antonino Stefano Borgia <stefano.borgia@pd.infn.it>
 *
 */

import java.net.URI;

import javax.xml.namespace.QName;

import org.apache.axis.MessageContext;
import org.apache.axis.encoding.DeserializerFactory;
import org.apache.axis.encoding.TypeMapping;
import org.apache.axis.encoding.TypeMappingImpl;
import org.apache.axis.encoding.TypeMappingRegistryImpl;
import org.apache.axis.encoding.ser.BeanDeserializerFactory;
import org.apache.axis.encoding.ser.BeanSerializerFactory;
import org.apache.axis.server.AxisServer;
import org.glite.ce.monitor.holder.PredefinedSubscriptionHolder;
import org.glite.ce.monitorapij.types.CEMonResource;
import org.glite.ce.monitorapij.types.Subscription;

import junit.framework.TestCase;

public class PredefinedSubscriptionHolderTest extends TestCase {


	private PredefinedSubscriptionHolder predefinedSubscriptionHolder = null;
	   private MessageContext messageContext = null;
	   private AxisServer axisServer = null;
	   private String path ="";
	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {

		TestUtilities testUtilities = new TestUtilities();
	   	messageContext= testUtilities.getMessageContext();
//	  	path = (String)messageContext.getProperty( "sensorConfigURI")+"config/predefinedSubscriptionList.xml";
	  	path = "file://"+(String)System.getProperty( "module.dir")+"/config/predefinedSubscriptionList.xml";// should point to config/predefinedSubscriptionList.xml here
	  	System.out.println(path);
	  	URI predefinedSubscriptionPath = new URI( path );
		predefinedSubscriptionHolder = new PredefinedSubscriptionHolder(messageContext,predefinedSubscriptionPath);
	}

	public void testPredefinedSubscriptionHolder() {
		assertNotNull(predefinedSubscriptionHolder);
	}

	public void testRun() {
		predefinedSubscriptionHolder.run();
		// by now predefinedSubscriptionList.xml does not exist. i put there subscription.xml
		// i must before define a correct typeMapping for Subscription.class to permit 
		// SubscriptionHandler to be created
	}



}
