/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Antonino Stefano Borgia <stefano.borgia@pd.infn.it>
 *
 */


import java.io.File;
import java.io.IOException;

import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.DeserializerFactory;

import org.apache.axis.ConfigurationException;
import org.apache.axis.InternalException;
import org.apache.axis.MessageContext;
import org.apache.axis.encoding.TypeMapping;
import org.apache.axis.encoding.TypeMappingImpl;
import org.apache.axis.encoding.TypeMappingRegistry;
import org.apache.axis.encoding.TypeMappingRegistryImpl;
import org.apache.axis.encoding.ser.BeanDeserializerFactory;
import org.apache.axis.encoding.ser.BeanSerializerFactory;
import org.apache.axis.server.AxisServer;
import org.apache.xerces.parsers.DOMParser;
import org.glite.ce.monitorapij.types.CEMonResource;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;
import org.apache.axis.deployment.wsdd.WSDDDeployment;
import org.apache.axis.deployment.wsdd.WSDDException;

/*
 * Created on Apr 19, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author borgia
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TestUtilities {
	
	private MessageContext messageContext = null;
	private AxisServer axisServer = null;

	/**
	 * 
	 */
	public TestUtilities() {
		setUpMessageContext();
		clearTestbed();
		setTypeMapping();

	}
	
	 private  void setUpMessageContext( ) {
	 	//TODO rivedere tutti i path

	 	
	 	if ( System.getProperty("module.dir") == null){
		   	  System.setProperty("module.dir","/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor");
	 	}
	 	if ( System.getProperty("monitor.dir") == null){
		   	  System.setProperty("monitor.dir","/home/borgia/usr/eclipse/TestWorkspace/org.glite.ce.monitor");
	 	}
	 	if ( System.getProperty("local_sensor_uri") == null){
		   	  System.setProperty("local_sensor_uri",System.getProperty("module.dir")+"/test");
	 	}
		messageContext = new MessageContext( axisServer );
		messageContext.setProperty( "sensorURI","file://"+System.getProperty("local_sensor_uri" ) );
		messageContext.setProperty( "sensorConfigURI", "file://"+System.getProperty("local_sensor_uri" )+"/sensorConfig.xml" );
		messageContext.setProperty( "subscriptionRegistryURI",System.getProperty("local_sensor_uri")+"/subscription.reg" );
		messageContext.setProperty( "resourceURI", "file://"+System.getProperty("local_sensor_uri" ));
		messageContext.setProperty( "queryProcessorURI","file://"+ System.getProperty("local_sensor_uri" ) );
		messageContext.setProperty( "queryProcessorConfigURI", "file://"+System.getProperty("local_sensor_uri" )+"/queryProcessorConfig.xml");
		messageContext.setProperty( "actionURI","file://"+ System.getProperty("local_sensor_uri" ) );
		messageContext.setProperty( "actionConfigURI", "file://"+System.getProperty("local_sensor_uri" )+"/actionConfig.xml" );
		messageContext.setProperty( "predefinedSubscriptionListPath","file://"+ System.getProperty("module.dir" )+"/config/predefinedSubscriptionList.xml" );
		messageContext.setProperty("wsddURI", "file://"+System.getProperty("monitor.dir")+"/config/server-config.wsdd");

		messageContext.setProperty( "monitorVersion","1.0" );
		messageContext.setProperty( "monitorDescription","First CE-Monitor prototype!" );
		
	}
	 
	 public void setTypeMapping(){
	 	/*
	 	TypeMappingRegistryImpl tmr = new TypeMappingRegistryImpl();
		TypeMapping typeMapping = null;
		TypeMappingImpl tmi = new TypeMappingImpl(typeMapping);
		QName testSensorQName = new QName("TestSensor");
		QName qName = new QName("CEMonResource");
		BeanSerializerFactory bsf = new BeanSerializerFactory(CEMonResource.class, qName);
		BeanDeserializerFactory bdsf = new BeanDeserializerFactory(CEMonResource.class, qName);
		tmi.register(CEMonResource.class,qName,bsf,bdsf);
		DeserializerFactory bdf;
		tmr.register("test",tmi);
		messageContext.setTypeMappingRegistry(tmr);
	 	*/
	 	
	 	String xmlFile = (String) messageContext.getProperty("wsddURI");
	 	//System.out.println(messageContext.getProperty("wsddURI"));
	 	//System.out.println(System.getProperty("monitor.dir"));
	 	DOMParser parser = new DOMParser();
	 	WSDDDeployment wsddDeployment = null;
	 	try {
	 	  parser.parse(xmlFile);
	 	} catch (SAXException se) { 
	 		se.printStackTrace(); }
	 	catch (InternalException ioe) {
	 		ioe.printStackTrace(); } 
	 	catch (IOException e) {
			e.printStackTrace();
		}
	 	Document document = parser.getDocument();
	 	Element element = document.getDocumentElement();
	 	try {
			wsddDeployment = new WSDDDeployment(element);
			TypeMappingRegistry typeMappingRegistry = wsddDeployment.getTypeMappingRegistry();
			messageContext.setTypeMappingRegistry(typeMappingRegistry);
		} catch (WSDDException e1) {
			e1.printStackTrace();
		} catch (ConfigurationException e) {
			e.printStackTrace();
		}
		
	 	
	 }
	 
	 private void clearTestbed(){
//		by now i'm testing only initialization phase, so i remove previously created sensorConfig.xml
		// otherwise the deserialization phase would start
	   	File sensorConfigFile = new File(System.getProperty("local_sensor_uri").toString()+"/sensorConfig.xml");
	   	
	   	File queryProcessorConfigFile = new File(System.getProperty("local_sensor_uri").toString()+"/queryProcessorConfig.xml");
	   	File actionConfigFile = new File(System.getProperty("local_sensor_uri").toString()+"/actionConfig.xml");
//	   	System.out.println(System.getProperty("local_sensor_uri").toString());
	    if(sensorConfigFile.exists()){
	    	System.out.println("deleting sensorConfig.xml");
	    	sensorConfigFile.delete();
	    	System.out.println("done");
	    }
	    if(queryProcessorConfigFile.exists()){
	    	System.out.println("deleting queryProcessorConfig.xml");
	    	queryProcessorConfigFile.delete();
	    	System.out.println("done");
	    }
	    if(actionConfigFile.exists()){
	    	System.out.println("deleting actionConfigFile.xml");
	    	actionConfigFile.delete();
	    	System.out.println("done");
	    }
	 }
	 
	 public MessageContext getMessageContext(){
	 	return messageContext;
	 }


}

